3 # vim:expandtab:shiftwidth=4:softtabstop=4:tabstop=4:
5 # this is an alternative FD for stdout, to be used especially when we are
6 # taking stdout from a function as it's return value. i.e. foo=$(bar)
7 # this is a workaround until a version of bash where we can put xtrace
13 if [[ $SHELLOPTS = *xtrace* ]]; then
18 # Assume that lbuild's support files can be found in the same
19 # canonicalized path as this very script.
20 LBUILD_SCRIPT=$(readlink -f ${0})
21 LBUILD_DIR=${LBUILD_DIR:-$(dirname ${LBUILD_SCRIPT})}
23 # include the exit_traps library
24 . ${LBUILD_DIR}/exit_traps.sh
25 . ${LBUILD_DIR}/funcs.sh
27 # our children should die when we do
28 push_exit_trap "kill -INT -$$ || true" kill_children
30 # increment this if you have made a change that should force a new kernel
33 #BUILD_GEN=2 # bz19952: remove -lustre tag from kernel RPM names
34 #BUILD_GEN=3 # bz19975: enable the building of src.rpms by default
35 #BUILD_GEN=4 # bz22281: use the git hash in the kernel extra version
36 #BUILD_GEN=5 # TT-107: don't cache the BUILD dir
37 BUILD_GEN=6 # TT-1092: don't cache the BUILD dir, to rebuild external OFED
45 # XXX - some recent hacking has pretty much neutered this option.
46 # search through this file for "-bb" and see how many places
47 # simply don't account for this option
52 TARGET_ARCH="$(uname -m)"
53 # change default behavior to only build for the current arch
54 TARGET_ARCHS="$TARGET_ARCH"
55 TARGET_ARCHS_ALL="$TARGET_ARCH"
56 [ "$TARGET_ARCH" = "i686" ] && TARGET_ARCHS_ALL="i686 i586 i386"
61 TMPDIR=${TMPDIR:-"/var/tmp"}
63 # this is the dir that should be used to store reuse products
65 # should cached products be used or force rebuilding?
67 # what does this do exactly? does it imply no kernel build?
72 SMPTYPES="smp bigsmp default ''"
79 # default to not adding -lustre- into the kernel RPM package names
80 KERNEL_LUSTRE_NAMING=false
81 # default not use kabi check.
99 # not in the target file any more
102 # build the lustre-tests rpm?
111 # Readlink is not present on some older distributions: emulate it.
115 if [ -L "$path" ]; then
116 ll="$(LC_ALL=C ls -l "$path" 2> /dev/null)" &&
125 Usage: ${0##*/} [OPTION]... [-- <lustre configure options>]
127 --external-patches=EXTERNAL_PATCHES
128 Directory similar to lustre/lustre/kernel_patches/ that lbuild should
129 look for seres and config files in before looking in the lustre
132 --extraversion=EXTRAVERSION
133 Text to use for the rpm release and kernel extraversion.
135 --timestamp=TIMESTAMP
136 Date of building lustre in format YYYYMMDDhhmmss
139 Try to reuse old kernel builds from DIR
142 Path to distro kernel RPM collection
148 Do not build RPMs (compile only mode)
151 Build lustre client only
154 Which distro using. Autodetect by default
156 --kerneldir=KERNELDIR
157 Directory containing Linux source tarballs referenced by target
160 --kerneltree=KERNELTREE
161 Directory containing dirs with Linux source tarballs referenced by target
162 files. Dir names in format kernel version ('2.6.9', etc.)
164 --linux=LINUX --with-linux=LINUX
165 Directory of Linux kernel sources. When this option is used, only
166 Lustre modules and userspace are built.
169 Path to an existing lustre source tarball to use.
172 Do not try to download a kernel from downloads.hpdd.intel.com
175 Do not build a .src.rpm, a full kernel patch, or a patched kernel
179 Build with ldiskfs support. (Deprecated, always true)
182 Do not build lustre-iokit RPM. Now true by default
188 Specifies that the files generated do not include timestamps, and
189 that this is an official release.
192 Build Lustre without ZFS.
195 Build a .src.rpm, a full kernel patch, and a patched kernel tarball.
198 Directory used to stage packages for release. RPMs will be placed
199 more or less in DIR/<target>-<arch>, and the tarball will be
203 The name of the target to build. The available targets are listed
206 --target-archs=TARGET_ARCHS
207 A (space delimited) list of architectures to build. By default,
208 all of the archs supported by the TARGET will be built, in
209 addition to a .src.rpm. This option can limit those, for machines
210 that can only build certain archs or if you only want a certain
211 arch built (for testing, or a one-off kernel).
213 Also note that by using a non-"base" arch (eg, i386) only kernels
214 will be built - there will be no lustre-lite-utils package.
217 Builds a Xen domX kernel.
220 Sets a variable to a given value.
229 # canonicalize a relative path to a file
233 if [ ! -f "$PATH" ]; then
237 local FILE=${PATH##*/}
240 echo $(canon_path "$DIR")/$FILE
244 # canonicalize a relative path to a dir
248 if [ ! -d "$PATH" ]; then
252 pushd "$PATH" >/dev/null || return 1
262 if [ -z "$LUSTRE" -o ! -r "$LUSTRE" ]; then
263 usage 1 "Could not find Lustre source tarball '$LUSTRE'."
266 if [ -z "$DISTRO" ] ; then
267 DISTRO=$(autodetect_distro)
271 DISTROMAJ=${DISTRO%%.*}
273 [ -z "$TARGET" ] && TARGET=$(autodetect_target "$DISTRO")
275 if [ -z "$LINUX" ]; then
276 [ "$KERNELDIR" -o "$KERNELTREE" ] || \
277 usage 1 "A kernel directory must be specified with --kerneldir or --kerneltree."
279 [ -d "$KERNELDIR" -o -d "$KERNELTREE" ] || \
280 usage 1 "$KERNELDIR and $KERNELTREE are not a directory."
282 # TARGET_FILE="$TOPDIR/lustre/kernel_patches/targets/$TARGET.target"
283 # [ -r "$TARGET_FILE" ] || \
284 # usage 1 "Target '$TARGET' was not found."
289 CANONICAL_TARGET="sles12"
292 CANONICAL_TARGET="rhel7"
295 CANONICAL_TARGET="rhel6"
298 CANONICAL_TARGET="rhel5"
301 CANONICAL_TARGET="rhel-2.6"
304 CANONICAL_TARGET="sles-2.6"
307 CANONICAL_TARGET="sles10-2.6"
309 2.6-sles11 | 3.0-sles11)
310 CANONICAL_TARGET="sles11"
313 CANONICAL_TARGET="oel5"
316 CANONICAL_TARGET="hp-pnnl-2.4"
324 CANONICAL_TARGET="$TARGET"
328 local timestampnodig=$(echo $TIMESTAMP | sed -e s/[0-9]*//g)
329 [ "$timestampnodig" = "" ] || TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
330 local timestamplength="${#TIMESTAMP}"
331 if [ $timestamplength -eq 12 ]; then
332 TIMESTAMP="${TIMESTAMP}00"
333 elif [ $timestamplength -ne 14 ]; then
334 TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
337 RPMBUILD=$(which rpmbuild 2>/dev/null | head -1)
338 if [ ! "$RPMBUILD" -o "$RPMBUILD" == "" ]; then
339 RPMBUILD=$(which rpm 2>/dev/null | head -1)
340 if [ ! "$RPMBUILD" -o "$RPMBUILD" == "" ]; then
341 usage 1 "Could not find binary for making rpms (tried rpmbuild and rpm)."
345 if [ -n "$CCACHE" ]; then
346 which "$DISTCC" &>/dev/null && export DISTCC RPM_BUILD_NCPUS
348 if which "$CCACHE" &>/dev/null; then
349 local ccache=$(which "$CCACHE")
350 local bindir="$TOPDIR/bin"
352 if [ ! -d $bindir ]; then
353 mkdir -p $bindir || fatal 1 "error trying to create $bindir"
355 rm ${bindir}/* > /dev/null 2>&1 || true
357 ln -s "$ccache" ${bindir}/ccache
358 ln -s "$ccache" ${bindir}/cc
359 ln -s "$ccache" ${bindir}/$CC
360 export PATH=$bindir:$PATH
361 export CCACHE && export CC="ccache $CC"
362 # zero the cache so we can see how effective we are being with it
366 # get some ccache stats when we are done
367 push_exit_trap '[ -n "$CCACHE" ] && ccache -s' "ccache_summary"
368 # should remove the ccache trap if lbuild is interrupted
369 trap 'echo "Received an INT TERM or HUP signal, terminating."; delete_exit_trap "ccache_summary"; exit 1' INT TERM HUP
377 # compare two versions $1 and $2. if $1 < $2, return 0 otherwise return 1.
379 [[ $1 == $2 ]] && return 1
381 local i val1=($1) val2=($2)
383 # padding zero to val1 if it needs
384 for ((i=${#val1[@]}; i<${#val2[@]}; i++)); do
387 for ((i=0; i<${#val1[@]}; i++)); do
388 [[ -z ${val2[i]} ]] && return 1
390 if [[ ${val1[i]} < ${val2[i]} ]]; then
392 elif [[ ${val1[i]} > ${val2[i]} ]]; then
400 echo $(echo "$*" | xargs -n 1 | sort -u)
408 if [ -z "$target" ]; then
409 fatal 1 "fetch_url() called without a target to fetch to"
412 if [ -d $target ]; then
413 target+="/${url##*/}"
417 if which wget >/dev/null 2>&1; then
418 if ! wget -nv "$url" -O "$target"; then
421 elif which curl >/dev/null 2>&1; then
422 if ! curl -n -L -s -o "$target" "$url"; then
426 fatal 1 "Could not find either wget or curl to fetch URLs."
436 local force="${3:-false}"
438 if $force || [ ! -r "$KERNELDIR/$srpm" ] ||
439 [ ! -s "$KERNELDIR/$srpm" ]; then
441 local location="https://downloads.hpdd.intel.com/public/kernels/$target/old"
442 # get the location from a distro specific method if it exists
443 if type -p kernel_srpm_location; then
444 location=$(kernel_srpm_location)
446 echo "Downloading $location/$srpm..."
447 if ! fetch_url "$location/$srpm" "$KERNELDIR/$srpm" 2>&1 ||
448 [ ! -s "$KERNELDIR/$srpm" ]; then
449 rm -f $KERNELDIR/$srpm
450 # punt to a distro specific method if it exists
451 if ! type -p download_srpm-$DISTROMAJ; then
452 fatal 1 "Could not download target $target's kernel SRPM $srpm from $location."
454 if ! download_srpm-$DISTROMAJ "$target" "$srpm" "$force"; then
455 fatal 1 "Could not download target $target's kernel SRPM $srpm using download_srpm-$DISTROMAJ."
460 fatal 1 "$srpm not found in directory $KERNELDIR."
471 local file=${from##*/}
477 local semaphore="$to-downloading"
480 if [ ! -f $semaphore ]; then
484 # make sure the download has not been aborted
485 local now=$(date +%s)
486 local file_mtime=$(stat -c %Y "$to")
487 local staleness=$((now - file_mtime))
488 # let's assume an active download will write at least once a minute
489 if [ $staleness -gt 60 ]; then
497 # if the semaphore file exists, the file is either still downloading
498 # or a download was aborted and we cannot trust the target file
499 if [ -f $semaphore ]; then
503 if ! is_downloading && [ -r "$to" ] && [ -s "$to" ]; then
510 if $force || ! is_downloaded; then
511 if is_downloading; then
512 echo "Somebody else is downloading $from..."
513 while is_downloading; do
514 echo "Waiting for $to to finish downloading"
517 if is_downloaded; then
520 echo "The download we were waiting for seems to have been aborted"
526 echo "Downloading $from..."
527 # flag others so they don't try to download also
528 push_exit_trap "rm -f $to $semaphore" "download"
530 if ! fetch_url "$from" "$to" || [ ! -s "$to" ]; then
531 # the trap will remove the files via the fatal below
532 fatal 1 "Could not download ${to##*/} from ${from%/*}/."
535 delete_exit_trap "download"
537 fatal 1 "${to##*/} not found in directory ${to%/*}."
546 local force="${1:-false}"
548 if [ -z "$OFED_VERSION" -o "$OFED_VERSION" = "inkernel" ]; then
552 local OFED_BASE_VERSION=$OFED_VERSION
553 if [[ $OFED_VERSION = *.*.*.* ]]; then
554 OFED_BASE_VERSION=${OFED_VERSION%.*}
557 local location="https://www.openfabrics.org/downloads/OFED/ofed-${OFED_BASE_VERSION}/"
559 if [[ $OFED_VERSION = *-[rR][cC][0-9] ]]; then
561 Mmv=${OFED_VERSION%%-[rR][cC][0-9]}
562 location="https://www.openfabrics.org/downloads/OFED/ofed-${Mmv}/"
565 if [[ $OFED_VERSION = daily-* ]]; then
567 Mmv=${OFED_VERSION/daily-/}
568 daily=${OFED_VERSION##$Mmv-}
569 location="https://www.openfabrics.org/downloads/OFED/ofed-${Mmv}-daily/"
570 # find the filename for the version for the date specified
571 OFED_VERSION=$(curl -s "$location" | sed -nre "/${Mmv}-/s/.*href=\"OFED-(${Mmv}-[0-9]{8,8}-[0-9]{4,4}).tgz.*$/\1/p" | tail -1)
572 if [ -z "$OFED_VERSION" ]; then
573 fatal 1 "Could not determine the filename of the OFED snapshot for ${daily}"
577 local file="OFED-${OFED_VERSION}.tgz"
578 download_file "$location/$file" "$KERNELTREE" "$force"
587 [ -r "$file" ] || fatal 1 "Could not find MPSS info file"
589 # convert to MPSS distro naming
590 distro=${distro/sles/suse}
591 distro_name=${distro%%-*}
593 # extract links from MPSS info file
594 local urls=$(cat "$file" | \
595 tr -d '\t\r\n' | sed -e 's?\(</[a-zA-Z]*>\)?\1\n?g' | \
596 grep '.intel.com/' | \
597 sed -e 's/^.*[hH][rR][eE][fF]="\([^>"]\+\)".*$/\1/g' | \
604 # Try to match with MPSS 3.3 package
605 if [[ $url =~ mpss-[0-9].[0-9](.[0-9]*)?-linux.tar ]]; then
607 ver3=${ver3%%-linux.tar}
608 # Try to match with MPSS 3.x or 3.x.x distro package
609 elif [[ $url =~ mpss-[0-9].[0-9](.[0-9]*)?-$distro.tar ]]; then
611 ver3=${ver3%%-$distro.tar}
612 # Try to match with MPSS 3.x or 3.x.x source package
613 elif [[ $url =~ mpss-src-[0-9].[0-9](.[0-9]*)?.tar ]]; then
614 ver3=${url##*mpss-src-}
616 # Try to match with MPSS 3.x or 3.x.x cross compiler package
617 elif [[ $url =~ mpss-[0-9].[0-9](.[0-9]*)?-k1om.tar ]]; then
619 ver3=${ver3%%-k1om.tar}
620 # Try to match with MPSS 2.1.x source package
621 elif [[ $url =~ _src-[0-9].[0-9].[0-9]*-[0-9]*_$distro_name.tar ]]; then
623 ver2=${ver2%%_$distro_name.tar}
626 if [ -n "$ver3" ]; then
628 if [ -z "$build" ]; then
630 elif [ "${build%%-*}" = "${ver3%%-*}" ]; then
633 elif [ -n "$ver2" ]; then
634 if [ -z "$build" ]; then
636 elif [ "$build" = "$ver2" ]; then
643 if [ -z "$build" ]; then
644 # return a last version of MPSS
645 if [ -n "$res3" ]; then
650 elif [ "${build%%.*}" = "3" ]; then
651 # return URLs from MPSS info file
654 # return URLs from MPSS info file
659 # Get public information about last releases of
660 # Intel Manycore Platform Software Stack (MPSS)
661 download_mpss_info() {
663 local force="${2:-true}"
664 local url=${MPSS_URL:-"http://software.intel.com/en-us/articles/intel-manycore-platform-software-stack-mpss"}
666 download_file "$url" "$file" "$force"
671 local force="${2:-false}"
672 local urls=$(parse_mpss_info "$file" ${MPSS_VERSION} ${MPSS_DISTRO})
674 [ -z "$urls" ] && return 0
679 file="$KERNELTREE/mpss_src-${MPSS_VER}-${MPSS_BLD}-${MPSS_DISTRO}-part$i.tar"
680 download_file "$url" "$file" "$force"
687 EXTRA_VERSION_save="$EXTRA_VERSION"
688 for patchesdir in "$EXTERNAL_PATCHES" \
689 "$TOPDIR/lustre/lustre/kernel_patches"; do
690 TARGET_FILE="$patchesdir/targets/$TARGET.target"
691 [ -r "$TARGET_FILE" ] && break
693 [ -r "$TARGET_FILE" ] || fatal 1 "Target $TARGET was not found."
695 echo "Loading target config file $TARGET.target..."
697 # if the caller specified an OFED_VERSION it should override whatever
698 # the target file specifies
699 local env_OFED_VERSION="$OFED_VERSION"
703 if [ -n "$env_OFED_VERSION" ]; then
704 OFED_VERSION="$env_OFED_VERSION"
707 # doesn't make any sense to build OFED for xen domX's
712 # XXX - set_rpm_smp_type is an ugly undeterministic hack. it needs to
713 # go away and the target just specify the $RPMSMPTYPE
714 [ -z "$RPMSMPTYPE" ] && set_rpm_smp_type
716 # CC might have been overwritten in TARGET_FILE
717 if [[ $CC != ccache\ * ]] && which "$CCACHE" &>/dev/null; then
718 export CCACHE && export CC="ccache $CC"
721 if [ ! "$KERNELTREE" = "" ] && [ -d "$KERNELTREE" ]; then
722 KERNELDIR="$KERNELTREE/${lnxmaj}"
723 [ -d "$KERNELDIR" ] || mkdir "$KERNELDIR"
726 # verify the series is available
727 if [ "$SERIES" ]; then
728 for series in $SERIES; do
729 for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
730 [ -r "$patchesdir/series/$series" ] && continue 2
732 fatal 1 "Target $TARGET's series $SERIES could not be found.\nSearched:\n\t$EXTERNAL_PATCHES/series\n\t$TOPDIR/lustre/lustre/kernel_patches/series."
736 # set the location of the .config file
742 if [ -f $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET-$TARGET_ARCH.config ]; then
743 CONFIG_FILE="$TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET$XENPOSTFIX-$TARGET_ARCH.config"
746 local lnxrelnew=${lnxrel//-/_}
748 # remember the EXTRA_VERSION before we diddle it here
749 # XXX - we really should not diddle with any values read in from the
750 # target file. if we want to modify a value, we should create
752 PRISTINE_EXTRA_VERSION=$EXTRA_VERSION
754 if ! $PATCHLESS && [ ! -f "$CONFIG_FILE" ]; then
755 fatal 1 "Config file for target $TARGET missing from $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/."
758 if [ "$EXTRA_VERSION_save" ]; then
759 EXTRA_VERSION="$EXTRA_VERSION_save"
760 elif ! $RELEASE; then
761 # if there is no patch series, then this is not a lustre specific
762 # kernel. don't make it look like one
763 if $PATCHLESS || [ -n "$SERIES" ]; then
764 EXTRA_VERSION=$(echo $EXTRA_VERSION | sed -e "s/\(.*_lustre\)\..*/\1/")
765 if ! $PATCHLESS && [ -n "$BUILDID" ]; then
766 EXTRA_VERSION="${EXTRA_VERSION}.${BUILDID}"
770 # EXTRA_VERSION=${EXTRA_VERSION//-/_}
772 ALL_ARCHS="$BASE_ARCHS $BIGMEM_ARCHS $BOOT_ARCHS $JENSEN_ARCHS $SMP_ARCHS $BIGSMP_ARCHS $PSERIES64_ARCHS $UP_ARCHS"
775 for arch in $(uniqify "$ALL_ARCHS"); do
776 if [ -z "$TARGET_ARCHS" ] ||
777 [[ \ $TARGET_ARCHS\ = *\ $arch\ * ]]; then
778 BUILD_ARCHS="$BUILD_ARCHS $arch"
781 [ "$BUILD_ARCHS" ] || usage 1 "No available target archs to build."
782 echo "Building for: $BUILD_ARCHS"
788 echo -n '--wildcards '
791 fatal 1 "tarflags(): File name argument missing."
803 fatal 1 "tarflags(): Unrecognized tar extension in file: $1"
812 local extractfile="$@"
814 echo "Untarring ${tarfile##*/}..."
815 tar $(tarflags "$tarfile") "$tarfile" $extractfile
821 if ! untar "$KERNELTREE/OFED-${OFED_VERSION}.tgz"; then
824 [ -d OFED ] || ln -sf OFED-[0-9].[0-9]* OFED
830 untar "$LUSTRE" || fatal 1 "Error unpacking Lustre tarball"
831 [ -d lustre ] || ln -sf lustre-[0-9].[0-9]* lustre
837 [ -d mpss ] && return 0
839 if [ "$MPSS_MAJ" = "3" ]; then
842 for i in $(seq 0 9); do
843 file="$KERNELTREE/mpss_src-${MPSS_VER}-${MPSS_BLD}-${MPSS_DISTRO}-part$i.tar"
844 if [ -r "$file" ]; then
846 "mpss-$MPSS_VER/*/linux-*.tar.bz2" \
847 "mpss-$MPSS_VER/*/kernel-dev-*.rpm" \
848 "mpss-$MPSS_VER/*/ofed-driver-devel-*.rpm" \
849 "mpss-$MPSS_VER/*/ofed-driver-*-devel-*.rpm"
852 # Extract kernel configs
853 file=$(find mpss-$MPSS_VER -type f -path "*/kernel-dev-*.rpm" -print -quit)
854 if ! rpm2cpio "$file" | cpio -idm; then
855 echo "Error extracting MPSS kernel configs"
858 # Unpack kernel sources
859 file=$(find mpss-$MPSS_VER -type f -path "*/linux-*.tar.bz2" -print -quit)
860 if ! untar "$file"; then
861 echo "Error unpacking MPSS kernel sources"
864 # Extract OFED headers
865 file=$(find mpss-$MPSS_VER -type f -path "*/ofed-driver-*-devel-*.rpm" -print -quit)
866 if ! rpm2cpio "$file" | cpio -idm; then
867 # Name was changed in MPSS 3.3
868 file=$(find mpss-$MPSS_VER -type f -path "*/ofed-driver-devel-*.rpm" -print -quit)
869 if ! rpm2cpio "$file" | cpio -idm; then
870 echo "Error extracting MPSS OFED headers"
874 # Remove unpacked archives to save space
875 rm -rf mpss-$MPSS_VER
876 # Make link to MPSS kernel sources
879 local dir="mpss-${MPSS_VER}-${MPSS_BLD}-${MPSS_DISTRO%%-*}"
881 mkdir $dir || return 255
882 pushd $dir >/dev/null || return 255
883 if ! untar "$KERNELTREE/mpss_src-${MPSS_VER}-${MPSS_BLD}-${MPSS_DISTRO}-part0.tar" "*/gpl/*full_src*"; then
886 echo "Error unpacking MPSS tarball 1"
889 local file=$(find . -type f -path "*/gpl/*full_src*")
890 if ! untar "$file"; then
893 echo "Error unpacking MPSS tarball 2"
904 local do_patch=${1:-true}
906 FULL_PATCH="$PWD/lustre-kernel-${TARGET}-${EXTRA_VERSION}.patch"
907 [ -f "$FULL_PATCH" ] && rm -f "$FULL_PATCH"
908 $do_patch && pushd linux >/dev/null
909 for series in $SERIES; do
910 echo -n "Applying series $series:"
911 for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
912 [ -r "$patchesdir/series/$series" ] || continue
913 SERIES_FILE="$patchesdir/series/$series"
914 for patch in $(<"$SERIES_FILE"); do
916 PATCH_FILE="$patchesdir/patches/$patch"
917 [ -r "$PATCH_FILE" ] || \
918 fatal 1 "Patch $patch does not exist in Lustre tree."
919 cat "$PATCH_FILE" >> "$FULL_PATCH" || {
921 fatal 1 "Error adding patch $patch to full patch."
924 patch -s -p1 < "$PATCH_FILE" 2>&1 || {
926 fatal 1 "Error applying patch $patch."
934 $do_patch && popd >/dev/null
935 echo "Full patch has been saved in ${FULL_PATCH##*/}."
945 pushd lustre >/dev/null
947 if ! build_lustre_dkms; then
948 popd >/dev/null # pushd lustre
952 echo "Building Lustre RPMs for: $BUILD_ARCHS..."
954 for arch in $BUILD_ARCHS; do
955 targets="--target $arch $targets"
958 local rpmbuildopt='-tb'
961 echo NORPM mode. Only compiling.
964 # If server we now build the spl and zfs modules against the lustre kernel.
965 # These are required prior to the building of lustre server. Client does
966 # not require spl/zfs. Use !PATCHLESS to indicate server which follows the
967 # line above so is at least consistant.
968 if [ $PATCHLESS == false ] && [ "x$WITH_ZFS" == "x" ]; then
969 if ! build_spl_zfs; then
970 popd >/dev/null # pushd lustre
976 RPMBUILD_DEFS="$RPMBUILD_DEFS --without servers"
977 if [ -n "$CROSS_SUFFIX" ]; then
978 RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"lustre_name lustre-client$CROSS_SUFFIX\""
982 # ditto for the lustre-tests boolean
983 if ! $LUSTRE_TESTS; then
984 RPMBUILD_DEFS="$RPMBUILD_DEFS --without lustre_tests"
988 RPMBUILD_DEFS="$RPMBUILD_DEFS --without lustre_iokit"
997 if $OSDLDISKFSRPM; then
1001 RPMBUILD_DEFS="$RPMBUILD_DEFS ${FIND_REQUIRES:+--define \"__find_requires $FIND_REQUIRES\"}"
1002 RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"configure_args ${CONFIGURE_FLAGS}\""
1003 RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"kdir $linux\""
1004 RPMBUILD_DEFS="$RPMBUILD_DEFS ${linuxobj:+--define \"kobjdir $linuxobj\"}"
1005 RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_tmppath $TMPDIR\""
1006 RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_topdir $TOPDIR\""
1008 eval $RPMBUILD $targets $rpmbuildopt "$LUSTRE" $RPMBUILD_DEFS \
1009 ${osd_zfs:+--with zfs} \
1010 ${osd_ldiskfs:+--with ldiskfs} 2>&1 || \
1011 fatal 1 "Error building rpms for $BUILD_ARCHS."
1014 if ! eval $RPMBUILD -ts "$LUSTRE" $RPMBUILD_DEFS 2>&1; then
1023 build_lustre_dkms() {
1024 [ -n "$MPSS_VERSION" ] && return 0
1025 local ver=$(eval echo $(awk '/LUSTRE_VERSION_STRING/ {print $3}' lustre/include/lustre_ver.h))
1026 echo "Building Lustre DKMS RPMs for: $BUILD_ARCHS..."
1027 ./configure --enable-dist || return 255
1028 $RPMBUILD --define="_topdir $TOPDIR" -bs lustre-dkms.spec || return 255
1029 $RPMBUILD --rebuild --define="_topdir $TOPDIR" $TOPDIR/SRPMS/lustre-dkms-$ver-*.src.rpm || return 255
1036 # Fetch spl/zfs from the git repo and prepare for lustre build
1039 # SPLZFSGITREPO - URI of directory where spl.git and zfs.git are located
1040 # SPLZFSTAG - Tag to checkout of clone repositories
1041 # SPLZFSVER - Version to checkout of both (format zfs/spl-$SPLZFSVER)
1043 # return 0 if successful, else 255
1045 # make sure the RPM build environment is set up
1047 create_rpmbuild_dirs
1050 # The spl/zfs spec files expect RPM_BUILD_ROOT to point to the root of the
1051 # destination for the rpms
1052 export RPM_BUILD_ROOT=$TOPDIR
1053 SPLZFSVER=${SPLZFSVER:-0.6.4.2}
1054 SPLZFSTAG=${SPLZFSTAG:-}
1056 # The files expect a kver to be set to the kernel version .
1057 local kver=$(find_linux_release)
1059 # build and install the spl and zfs (and -devel) RPMs for lustre to use
1061 for pkg in spl zfs; do
1065 [ "$pkg" == "zfs" ] && spldir="$(ls -d $TOPDIR/usr/src/spl-*/|tail -1)"
1067 # need to fetch the repo in order to build it.
1068 # default to github but allow override
1069 git clone ${SPLZFSGITREPO:-"https://github.com/zfsonlinux"}/$pkg.git $pkg 2>&1
1071 pushd $pkg || return 255
1072 if [ -n "$SPLZFSTAG" ]; then
1073 git checkout $SPLZFSTAG
1075 git checkout -b lbuild $pkg-$SPLZFSVER
1078 # This differentiates between older zfs versions
1079 if [ -f $pkg-modules.spec.in ]; then
1082 speclist="$pkg.spec $rpmpkg.spec"
1084 rpmpkg=kmod-$pkg-devel
1086 speclist="$pkg.spec $pkg-kmod.spec $pkg-dkms.spec"
1089 sh autogen.sh || return 255
1091 if ! ./configure --with-linux=${LINUX} --with-linux-obj=${LINUXOBJ:-$LINUX} \
1092 ${spldir:+--with-spl="${spldir}"} 2>&1 ||
1093 ! make dist 2>&1; then
1099 ln -f $pkg/$pkg-*.tar.gz $TOPDIR/SOURCES ||
1100 error "failed to link $pkg/$pkg-*.tar.gz into $TOPDIR/SOURCES"
1101 if [ -f $pkg/scripts/kmodtool ]; then
1102 ln -f $pkg/scripts/kmodtool $TOPDIR/SOURCES/
1112 # set search dir for our own kmodtool to find correct
1114 export KERNELSOURCE=$(dirname ${LINUX})
1115 # Manually build rpms
1116 for spec in $speclist; do
1117 echo "Building RPMs from $pkg/$specdir/$spec"
1118 if ! $RPMBUILD $rpmb $pkg/$specdir/$spec \
1120 --define "require_kdir ${LINUX}" \
1121 ${LINUXOBJ:+--define "require_kobj ${LINUXOBJ}"} \
1122 ${spldir:+--define "require_spldir ${spldir}"} \
1123 --define "kver $kver" \
1124 --define "kernels $kver" \
1125 --define "_tmppath /var/tmp" \
1126 --define "kernelbuildroot $TOPDIR/reused" \
1127 --define "_topdir $TOPDIR" 2>&1; then
1132 # We have built the rpms for the package. Now we need to extract the
1133 # contained files so we can build further things against them
1134 local rpms=$(ls -1 $TOPDIR/RPMS/*/$rpmpkg-*.rpm)
1136 # cpio only extract to pwd so we need to go there.
1139 for rpm in $rpms; do
1140 rpm2cpio $rpm | cpio -id
1143 if [ "$pkg" == "zfs" ]; then
1144 # We also need to extract both the zfs and zfs-devel rpms
1145 # the zfs rpm is needed because it has the actual libraries in
1146 # it and the zfs-devel rpm only has unversioned symlinks to the
1147 # libraries in the zfs rpm
1148 # this will all change one day when we have a libzfs rpm per
1149 # https://github.com/zfsonlinux/zfs/issues/2329
1150 # and it looks like it could be one day soon:
1151 # https://github.com/zfsonlinux/zfs/pull/2341
1152 local devel_rpms=$(ls -1 $TOPDIR/RPMS/*/{$pkg-devel,$pkg-$SPLZFSVER,lib*}-*.rpm)
1153 for rpm in $devel_rpms; do
1154 rpm2cpio $rpm | cpio -id
1156 CONFIGURE_FLAGS="--with-$pkg-devel=$TOPDIR ${CONFIGURE_FLAGS}"
1160 CONFIGURE_FLAGS="--with-$pkg=$(ls -d $TOPDIR/usr/src/$pkg-*/|tail -1) ${CONFIGURE_FLAGS}"
1161 CONFIGURE_FLAGS="--with-$pkg-obj=$(ls -d $TOPDIR/usr/src/$pkg-*/$kver*|tail -1) ${CONFIGURE_FLAGS}"
1171 pushd mpss >/dev/null || return 255
1172 if [ "$MPSS_MAJ" = "3" ]; then
1173 cp -f ../boot/config-* .config
1174 if ! make ARCH=k1om silentoldconfig ; then
1178 if ! make ARCH=k1om modules_prepare ; then
1182 cp -f ../boot/Module.symvers-* Module.symvers
1184 if ! make defconfig-miclinux; then
1188 if ! make -C card/kernel ARCH=k1om modules_prepare ; then
1199 [ "$STAGEDIR" ] || return 0
1201 for arch in $BUILD_ARCHS; do
1202 rpmdir="${STAGEDIR}/${CANONICAL_TARGET}-${arch}"
1203 echo "${0##*/}: Copying RPMs into ${rpmdir}"
1204 mkdir -p "${rpmdir}"
1205 cp -v RPMS/${arch}/*.rpm "${rpmdir}"
1206 if [ -d RPMS/noarch ]; then
1207 cp -v RPMS/noarch/*.rpm "${rpmdir}"
1211 cp -v "$LUSTRE" "$STAGEDIR"
1215 set_rpm_smp_type() {
1217 local infact_arch="${TARGET_ARCH}"
1220 [ "$infact_arch" == "i586" ] && infact_arch="i686"
1223 for smp_type in $SMP_ARCHS; do
1224 [ $infact_arch == $smp_type ] && RPMSMPTYPE=smp && break
1227 for smp_type in $BIGSMP_ARCHS; do
1228 [ $infact_arch == $smp_type ] && RPMSMPTYPE=bigsmp && break
1231 for smp_type in $PPC64_ARCHS; do
1232 [ $infact_arch == $smp_type ] && RPMSMPTYPE=ppc64 && break
1235 for smp_type in $DEFAULT_ARCHS; do
1236 [ $infact_arch == $smp_type ] && RPMSMPTYPE=default && break
1241 # This function takes a linux include tree and digs out the linux release
1242 # from it. It is never called directly, only called from the distro
1243 # specific function find_linux_release() in lbuild-{rhel,sles}.
1244 _find_linux_release() {
1246 local LINUXRELEASEHEADER=""
1248 LINUXRELEASEHEADER=$SRC/include/linux/version.h
1249 if [ -s $SRC/include/generated/utsrelease.h ]; then
1250 LINUXRELEASEHEADER=$SRC/include/generated/utsrelease.h
1251 elif [ -s $SRC/include/linux/utsrelease.h ]; then
1252 LINUXRELEASEHEADER=$SRC/include/linux/utsrelease.h
1255 if [ ! -s $LINUXRELEASEHEADER ]; then
1256 fatal 1 "could not find UTS_RELEASE"
1259 sed -ne 's/#define UTS_RELEASE "\(.*\)"$/\1/p' $LINUXRELEASEHEADER
1262 # unpack kernel(/source/devel) RPM
1264 # This function and it's setting of $LINUX and $LINUXOBJ is a total hack that
1265 # needs to completely refactored. It completely ingores that $BUILD_ARCHS may
1266 # contain a list of arches for which rpmbuild commands (including the one for
1268 unpack_linux_devel_rpm() {
1269 local kernelrpm="${1}"
1271 [ -f "$kernelrpm" ] || return 255
1272 [ -d $TOPDIR/reused ] || mkdir $TOPDIR/reused || return 255
1274 pushd $TOPDIR/reused &>/dev/null || return 255
1276 if ! rpm2cpio < "$kernelrpm" | cpio -id > /dev/null 2>&1; then
1280 # call a distro specific hook, if available
1281 if type -p unpack_linux_devel_rpm-$DISTROMAJ; then
1282 if ! unpack_linux_devel_rpm-$DISTROMAJ "$kernelrpm"; then
1289 find_linux_devel_paths $TOPDIR/reused
1297 local kib_prefix="$2"
1300 # build kernel-ib{,-devel}/compat-rdma{,-devel}
1302 # ofed 1.3 had a bug in the rpm spec
1303 if [ "$OFED_VERSION" = "1.3" ]; then
1307 local OFED_CORE="--with-core-mod --with-ipoib-mod --with-user_mad-mod --with-user_access-mod --with-addr_trans-mod"
1308 local OFED_HARDWARE="--with-mthca-mod --with-mlx4-mod --with-mlx4_en-mod --with-cxgb3-mod --with-nes-mod --with-qib-mod"
1310 if compare_version $OFED_VERSION 3.0; then
1311 OFED_CORE="$OFED_CORE --with-madeye-mod --with-rds-mod"
1313 OFED_HARDWARE="$OFED_HARDWARE --with-mlx5-mod --with-cxgb4-mod --with-ocrdma-mod --with-qib-mod"
1316 # some I/B drivers are architecture dependent and kernel-ib's configure
1317 # does not figure it out for us ~sigh~
1318 case "$TARGET_ARCH" in
1320 OFED_HARDWARE="$OFED_HARDWARE --with-ehca-mod"
1323 # we're no longer shipping the OFED iSCSI target
1324 #OFED_ISCSI="--with-srp-mod --with-srp-target-mod"
1325 OFED_ISCSI="--with-srp-mod"
1326 ## ISER module has no backport support as of OFED 1.5 (i.e. only builds on
1327 ##kernels >= 2.6.30)
1328 #if [[ $OFED_VERSION = 1.[0-4]* ]]; then
1329 # OFED_ISCSI="$OFED_ISCSI --with-iser-mod"
1332 # assume we are just rebuilding the SRPM
1333 local BUILD_TYPE=${BUILD_TYPE:-"--rebuild"}
1334 local SOURCE="${TOPDIR}/OFED/SRPMS/${kib_prefix}-*.src.rpm"
1336 # but switch to building from the SPEC if we need to apply patches
1337 if ls ${TOPDIR}/lustre/contrib/patches/ofed/* >/dev/null; then
1339 rpm --define "_topdir ${TOPDIR}" -ivh $SOURCE
1340 SOURCE="${TOPDIR}/SPECS/${kib_prefix}.spec"
1341 local file ed_fragment1 ed_fragment2 n=1
1342 for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.patch); do
1343 ed_fragment1="$ed_fragment1
1344 Patch$n: ${file%%*/}"
1345 ed_fragment2="$ed_fragment2
1347 cp $file ${TOPDIR}/SOURCES
1350 for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.ed); do
1351 # Only apply the ed-scripts that should be used for the canonical target
1352 # ed-files in ${TOPDIR}/lustre/contrib/patches/ofed/ have to follow the naming
1354 # <two-digits>-<descriptive-name>:<canonical_target_1>: ...:<canonical_target_N>.ed
1355 # To apply the same change to multiple canonical target simply specify
1356 # a list of colon separated canoncial target names in the file name.
1357 echo "$file" | grep -q -e ":${CANONICAL_TARGET}:" \
1358 -e ":${CANONICAL_TARGET}.ed$"
1359 if [ $? -eq 0 ] ; then
1360 ed_fragment3="$ed_fragment3
1366 if [ $n -gt 1 ]; then
1380 local linuxrelease=$(find_linux_release)
1381 if compare_version $OFED_VERSION 3.0; then
1382 local OFA_KERNEL_RELEASE=$(echo -n ${linuxrelease} | sed -e 's/-/_/g')
1384 if ! $RPMBUILD $BUILD_TYPE --define 'build_kernel_ib 1' --define 'build_kernel_ib_devel 1' \
1385 ${FIND_REQUIRES:+--define "__find_requires $FIND_REQUIRES"} \
1386 --define "_topdir ${TOPDIR}" --target ${TARGET_ARCH} \
1387 --define "KVERSION ${linuxrelease}" \
1388 --define "$K_SRC ${linux}" \
1389 --define "LIB_MOD_DIR /lib/modules/${linuxrelease}/updates" \
1390 ${OFA_KERNEL_RELEASE:+--define "_release $OFA_KERNEL_RELEASE"} \
1391 --define "configure_options --without-quilt $OFED_CORE $OFED_HARDWARE $OFED_ISCSI" \
1392 ${SOURCE} 2>&1; then
1393 fatal 1 "Error building ${kib_rpm}"
1402 local signature="$4"
1403 local use_links="$5"
1410 local default_iface=$(/sbin/ip route get 192.1.1.1 | sed -ne 's/.* dev \(.*\) * src .*/\1/p')
1411 if [ -z "$default_iface" ]; then
1412 fatal 1 "Failed to determine the default route interface"
1414 local unique_id=$(/sbin/ip addr show dev $default_iface | sed -ne '/ inet /s/ *inet \(.*\)\/.*/\1/p' | head -1)
1415 if [ -z "$unique_id" ]; then
1416 fatal 1 "Failed to determine a unique id from interface $default_interface"
1419 local finallocation="$location"/"$signature"/"$module"
1420 location="$location"/"$signature-${unique_id}"/"$module"
1421 mkdir -p "$location"
1422 # the cleanup script removes any directory that doesn't have a
1423 # .lastused, so let's try to prevent that as soon as we can
1424 # this solution still slightly racy with the cleanup script
1425 # but the race is a lot tighter now
1426 touch -t 197001010000 "$location/.lastused"
1427 ## use eval/echo here to make sure shell expansions are performed
1428 #if ! cp -a${linkflag} $(eval echo $articles) "$location"; then
1430 for article in $(eval echo $articles); do
1431 if ! cp -a${linkflag} "$article" "$location"; then
1432 error "Failed to copy \"$article\" to \"$location\" in store_for_reuse()"
1433 # rename the cache location so that it's not cached
1434 # product, but is around for analysis
1435 mv "$location"{,-bad-$(date +%s)} ||
1436 error "failed to clean up a failed cache attempt" \
1437 "in \"$location\" -- manual cleanup will be" \
1443 # flag the cache as complete (i.e. in case lbuild was previously
1444 # interrupted while caching)
1445 touch "$location/.lastused"
1447 # put the temporary location into the final location
1449 mkdir -p "${finallocation%/*}"
1450 mv "$location" "$finallocation"
1451 rmdir "${location%/*}"
1459 local use_links="${3:-false}"
1460 local signature="$4"
1462 if [ -n "$REUSEBUILD" ] && [ -d "$REUSEBUILD/$signature/$module" ]; then
1463 if [ ! -f "$REUSEBUILD/$signature/$module/.lastused" ]; then
1464 # the .lastused flag is populated at the end of the caching to
1465 # signal that the caching was completed. if that flag is not
1466 # there, then the cache is invalid (and should be removed in fact)
1467 mv "$REUSEBUILD/$signature/$module"{,-bad-$(date +%s)} ||
1468 fatal 1 "failed to clean up a bad cache in location $REUSEBUILD/$signature/$module\" -- manual cleanup will be necessary"
1472 # so that we know how stale this entry is
1473 touch $REUSEBUILD/$signature/$module/.lastused
1476 if ls $REUSEBUILD/$signature/$module/* >/dev/null 2>&1; then
1477 cp -al $REUSEBUILD/$signature/$module/* $dest/
1480 # copying is pretty heavy
1481 # cp -a $REUSEBUILD/$signature/$module/* $dest/
1482 # do some creative symlinking instead
1484 for dir in BUILD SRPMS SPECS; do
1485 if ls $REUSEBUILD/$signature/$module/$dir/* >/dev/null 2>&1; then
1486 ln -s $REUSEBUILD/$signature/$module/$dir/* $dest/$dir
1489 # sources have to be copied by file because we need SOURCES to
1490 # be a dir we can write into
1491 # could overrun ls's arg list here
1492 #ls $REUSEBUILD/$signature/$module/SOURCES/* |
1493 find $REUSEBUILD/$signature/$module/SOURCES/ -type f |
1494 xargs ln -t $dest/SOURCES -s
1496 # same for RPMS/* dirs
1497 # could overrun ls's arg list here
1498 #ls $REUSEBUILD/$signature/$module/RPMS/$TARGET_ARCH/* |
1500 for dir in $REUSEBUILD/$signature/$module/RPMS/*; do
1501 mkdir -p $dest/RPMS/${dir##*/}
1503 xargs ln -t $dest/RPMS/${dir##*/} -s
1515 if [[ $arch = i[3456]86 ]]; then
1523 build_kernel_with_srpm() {
1526 if [ -z "$outfd" ] || [ $outfd = 1 ]; then
1527 fatal 1 "You must supply a file descriptor to ${FUNCNAME[0]} and it cannot be 1"
1530 # need to generate the patch for this target
1531 do_patch_linux false >&${outfd} # sets global $FULL_PATCH (yeah, yuck)
1533 # get an md5sum of the kernel patch + config for reuse check
1534 # XXX really, there needs to be a signature and a CONFIG_FILE per arch
1538 local release_str="RELEASE=$RELEASE\n"
1541 if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1542 local REUSE_SIGNATURE=$({ echo -en $release_str;
1547 cat "$LBUILD_DIR/lbuild";
1548 cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
1549 md5sum | cut -d" " -f1)
1550 # see if we can link to the reuse pool
1551 # XXX - hrm. i'm not convinced this doesn't belong in the reuse
1553 local CAN_LINK_FOR_REUSE=false
1554 touch $REUSEBUILD/$$
1555 if cp -al $REUSEBUILD/$$ $TOPDIR/ 2>/dev/null; then
1556 CAN_LINK_FOR_REUSE=true
1561 # the extra version string to use for the kernel (which might be a reused
1563 local kernel_extra_version=""
1564 if ! $USE_BUILD_CACHE || ! reuse kernel "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1565 "$REUSE_SIGNATURE"; then
1566 # nothing cached, build from scratch
1567 if [ ! -r "$KERNELDIR/$KERNEL_SRPM" ]; then
1568 echo "Downloading kernel SRPM" >&${outfd}
1569 download_srpm "$CANONICAL_TARGET" "$KERNEL_SRPM" >&${outfd}
1572 if ! rpm -ivh $KERNELDIR/$KERNEL_SRPM \
1573 --define "_topdir $TOPDIR" >&${outfd} 2>&1; then
1574 # should we clean this up or leave it for analysis?
1576 fatal 1 "Error installing kernel SRPM."
1579 # put the Lustre kernel patch into the RPM build tree
1580 cp $FULL_PATCH $TOPDIR/SOURCES/linux-${lnxmaj}-lustre.patch
1581 prepare_and_build_srpm >&${outfd} ||
1582 fatal 1 "failed to prepare_and_build_srpm"
1584 if [ -z "$REUSE_SIGNATURE" ]; then
1585 echo "No reuse signature was caculated so not storing the built kernel" >&${outfd}
1587 # store the resulting kernel RPM build tree for future use
1588 echo "Storing the built kernel for future reuse" >&${outfd}
1589 if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,SRPMS,RPMS}" \
1590 "kernel" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1591 "$CAN_LINK_FOR_REUSE"; then
1592 error "Failed to store kernel RPMS for reuse"
1593 echo "unknown" >&${outfd}
1599 # figure out the EXTRA_VERSION of the kernel we built or are re-using
1601 if ! KERNEL_RPM=$(find_rpm "$TOPDIR/RPMS/$TARGET_ARCH/" provides "^kernel(-default)? ="); then
1602 fatal 1 "Failed to find a kernel RPM in $TOPDIR/RPMS/$TARGET_ARCH/"
1604 kernel_extra_version=$(rpm -q --queryformat "%{RELEASE}" -p $TOPDIR/RPMS/$TARGET_ARCH/$KERNEL_RPM)
1606 # should now have the following RPMs
1607 # $TOPDIR/RPMS/$arch/kernel-lustre-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1608 # $TOPDIR/RPMS/$arch/kernel-lustre-devel-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1609 # $TOPDIR/RPMS/$arch/kernel-lustre-headers-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1610 # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-common-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1611 # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1613 echo $kernel_extra_version
1621 # REUSEBUILD, USE_BUILD_CACHE
1626 local ofed_version="$2"
1630 # if an ofed version is given, then it means use OFED proper,
1631 # not any vendor specific "inkernel" version
1632 if [ -z "$ofed_version" ]; then
1636 if [ "$ofed_version" = "inkernel" ]; then
1637 # see if there is a distro specific override for this and use
1639 # XXX we need to better integrate a distro specific override with
1640 # the rest of this function so that all of the reuse cache
1641 # stuff is leveraged given that 80% of this function is reuse
1642 if type -p build_ofed-$DISTROMAJ; then
1644 ofed_location=$(build_ofed-$DISTROMAJ ${STDOUT})
1645 local rc=${PIPESTATUS[0]}
1646 CONFIGURE_FLAGS="--with-o2ib=${ofed_location} ${CONFIGURE_FLAGS}"
1651 elif compare_version $OFED_VERSION 3.0; then
1652 kib_prefix="ofa_kernel"
1655 kib_prefix="compat-rdma"
1656 kib_rpm="compat-rdma"
1659 # build kernel-ib/compat-rdma
1660 if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1661 local REUSE_SIGNATURE=$({ echo "$ofed_version";
1662 echo "$(find_linux_release;
1663 echo "$BUILD_GEN")";
1664 cat "${linux}/include/linux/autoconf.h";
1665 cat "$LBUILD_DIR/lbuild";
1666 cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
1667 md5sum | cut -d" " -f1)
1668 # see if we can link to the reuse pool
1669 # XXX - hrm. i'm not convinced this doesn't belong in the reuse
1671 local CAN_LINK_FOR_REUSE=false
1672 touch $REUSEBUILD/$$
1673 if cp -al $REUSEBUILD/$$ $TOPDIR/; then
1674 CAN_LINK_FOR_REUSE=true
1679 if ! $USE_BUILD_CACHE || ! reuse ofed "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1680 "$REUSE_SIGNATURE"; then
1681 if [ -n "$REUSE_SIGNATURE" ]; then
1682 # stash away the existing built articles for a moment
1684 mv {BUILD,{S,}RPMS,S{OURCE,PEC}S} bak
1687 find . | cpio -pudlm ..
1691 create_rpmbuild_dirs
1694 build_kernel_ib "${linux}" "${kib_prefix}" "${kib_rpm}"
1696 if [ -z "$REUSE_SIGNATURE" ]; then
1697 echo "No reuse signature was caculated so not storing the built ofed"
1699 # store the resulting RPM build tree for future use
1700 echo "Storing the built ofed for future reuse"
1701 if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,BUILD,SRPMS,RPMS}" \
1702 "ofed" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1703 "$CAN_LINK_FOR_REUSE"; then
1704 error "Failed to store OFED RPMS for reuse"
1708 # put the stuff we stashed away back
1713 pushd "$TOPDIR" >/dev/null
1714 rm -rf ${kib_rpm}-devel
1715 mkdir ${kib_rpm}-devel
1717 # the actual ofed RPMs don't have the -rc$n or -$date string appened that
1718 # might be present on the file
1719 #local linuxrelease=$(find_linux_release)
1720 #ofed_version=$(echo $ofed_version |
1721 # sed -re 's/-(20[0-9]{6,6}-[0-9]{4,4}|rc[0-9]*)$//')
1723 # OFED version will have 'hyphen' for minor release. (e.g. 3.5-1, instead
1724 # of 3.5.1) compat-rdma and compat-rdma-devel could have same version
1725 # number, but currectly not. Once OFED fix this in the future release, we
1726 # can remove following filter.
1727 #ofed_version=$(echo $ofed_version |
1728 # sed -re 's/-([0-9]*-[rR][cC][0-9]*)$//')
1729 #local rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-${ofed_version}-${linuxrelease//-/_}.*.rpm)
1730 # I dont' know why we have gone through the trouble to filter out the name
1731 # of the rpm there should only be one ${kib_rpm}-devel built
1732 local rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-*.rpm)
1733 if ! rpm2cpio < $rpm | cpio -id; then
1734 fatal 1 "could not unpack the ${kib_rpm}-devel rpm."
1736 CONFIGURE_FLAGS="--with-o2ib=$(pwd)/usr/src/${kib_prefix} ${CONFIGURE_FLAGS}"
1743 if ! $PATCHLESS; then
1744 local kernel_extra_version
1745 if ! kernel_extra_version=$(build_kernel_with_srpm ${STDOUT}); then
1746 fatal 1 "Failed to build the kernel from it's SRPM"
1749 for arch in $BUILD_ARCHS; do
1750 local kernel_devel_rpm
1751 if ! kernel_devel_rpm=$(find_rpm "$TOPDIR/RPMS/$arch/" provides "^$(devel_kernel_name $KERNEL_LUSTRE_NAMING) ="); then
1752 fatal 1 "Failed to find a kernel development RPM in $TOPDIR/RPMS/$arch/"
1755 # install the -devel RPM in preparation for modules builds
1756 if ! lnxrel="$kernel_extra_version" unpack_linux_devel_rpm \
1757 "$TOPDIR/RPMS/$arch/$kernel_devel_rpm"; then
1758 fatal 1 "Could not find the Linux tree in $TOPDIR/RPMS/$arch/$kernel_devel_rpm"
1762 # need to find and unpack the vendor's own kernel-devel for patchless
1765 if ! kernelrpm=$(find_linux_rpm "-$DEVEL_KERNEL_TYPE"); then
1766 fatal 1 "Could not find the kernel-$DEVEL_KERNEL_TYPE RPM in $KERNELRPMSBASE/$lnxmaj/$DISTROMAJ"
1768 if ! lnxrel="$lnxrel" unpack_linux_devel_rpm "$kernelrpm" "-"; then
1769 fatal 1 "Could not find the Linux tree in $kernelrpm"
1773 # ~sigh~ have to make copies of and modify some of the rpm
1774 # infrastructure files so that find-requires can find our unpacked
1775 # kernel-devel artifacts
1776 cp $RPM_HELPERS_DIR/{symset-table,find-requires{,.ksyms}} .
1777 FIND_REQUIRES="$(pwd)/find-requires"
1778 chmod 755 {symset-table,find-requires{,.ksyms}}
1780 tmp="${tmp//\//\\/}"
1781 ed find-requires <<EOF
1785 /|.*find-requires.ksyms/s/|/| bash -x/
1786 g/ [^ ]*\/\(find-requires\.ksyms\)/s// $tmp\/\1/g
1789 ed find-requires.ksyms <<EOF
1793 g/\/.*\/\(symset-table\)/s//$tmp\/\1/g
1796 ed symset-table <<EOF
1800 g/\(\/boot\/\)/s//$tmp\/reused\1/g
1801 g/\(\/usr\/src\/kernels\/\)/s//$tmp\/reused\1/g
1805 build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_VERSION" ||
1806 fatal 1 "error building OFED"
1809 if build_lustre "$LINUX" "$LINUXOBJ"; then
1810 # the build worked. resolve any symlinked files (i.e. from reuse)
1811 # in RPMS/$arch to real files so that that that huge mess of
1812 # complication known as LTS can copy them yet somewhere else.
1813 # is it any wonder this whole process is so damn so? anyone ever
1814 # heard of hardlinks? it's this cool new thing that allows you save
1815 # tons of time and space by creating... well you can go read about
1816 # them if you have not heard about them yet.
1817 # can i say how much the implemenation of all of this really impedes
1820 for dir in RPMS/*; do
1822 for file in $(ls); do
1823 if [ -h $file ]; then
1830 # also, for i?86, make sure all of the RPMs are in RPMS/$TARGET_ARCH
1831 # as that's where LTS expects to find them
1832 for dir in RPMS/*; do
1833 if [ $dir = RPMS/$TARGET_ARCH ]; then
1838 if [ -n "$files" ]; then
1839 cp -al $files ../$TARGET_ARCH
1849 create_rpmbuild_dirs() {
1851 [ -d RPMS ] || mkdir RPMS
1852 for arch in $BUILD_ARCHS; do
1853 if [[ $arch = i?86 ]]; then
1854 # some stupidity in the sles11 kernel spec requires an RPMS/i386
1855 # even if the target arch is i686
1856 [ -d RPMS/i386 ] || mkdir RPMS/i386
1858 [ -d RPMS/$arch ] || mkdir RPMS/$arch
1860 [ -d RPMS/noarch ] || mkdir RPMS/noarch
1861 [ -d BUILD ] || mkdir BUILD
1862 [ -d SOURCES ] || mkdir SOURCES
1863 [ -d SPECS ] || mkdir SPECS
1864 [ -d SRPMS ] || mkdir SRPMS
1886 [[ $list\ == *\ $item\ * ]]
1890 #########################################################################
1891 # Generate a backtrace through the call stack.
1895 #########################################################################
1899 local funcname="" sourcefile="" lineno="" n
1901 echo "Call stack: (most recent first)"
1902 for (( n = $strip ; n < ${#FUNCNAME[@]} ; ++n )) ; do
1903 funcname=${FUNCNAME[$n - 1]}
1904 sourcefile=$(basename ${BASH_SOURCE[$n]})
1905 lineno=${BASH_LINENO[$n - 1]}
1909 # Display function arguments
1910 if [[ ! -z "${BASH_ARGV[@]}" ]]; then
1911 local args newarg j p=0
1912 for (( j = ${BASH_ARGC[$n - 1]}; j > 0; j-- )); do
1913 newarg=${BASH_ARGV[$j + $p - 1]}
1914 args="${args:+${args} }'${newarg}'"
1916 let p+=${BASH_ARGC[$n - 1]}
1918 echo " ${funcname} ${args:+${args} }at ${sourcefile}:${lineno}"
1922 echo "BEGIN BACKTRACE"
1924 #echo ${BASH_LINENO[*]}
1925 #echo ${BASH_SOURCE[*]}
1926 #echo ${FUNCNAME[*]}
1927 local i=$((${#FUNCNAME[@]} - 1))
1928 while [ $i -ge 0 ]; do
1929 local lineno=${BASH_LINENO[$i]}
1933 local SOURCELINE="${BASH_SOURCE[$i + 1]}:${lineno}"
1934 # Can't figure out how to get function args from other frames...
1935 local FUNCTION="${FUNCNAME[$i]}()"
1936 echo "$SOURCELINE:$FUNCTION"
1940 echo "END BACKTRACE"
1946 seen_list=$(new_list)
1948 echo "An unexpected error has occurred at ${BASH_SOURCE[0]##*/}:$((LINENO-1)).
1949 Unfortunately the above line number in the message may or may not be correct,
1950 but details have been send to the lbuild maintainer. Attempting to continue."; (echo "Untrapped error"
1952 # have we seen this one
1953 echo "checking seen list for ${BASH_SOURCE[0]}:${BASH_LINENO[0]}"
1955 if is_list_member "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}"; then
1956 echo "seen this one already"
1958 seen_list=$(add_list "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}")
1961 ) ; set $xtrace' ERR
1964 [ -r ~/.lbuildrc ] && . ~/.lbuildrc
1966 options=$(getopt -o D:h -l kerneltree:,distro:,kernelrpm:,reusebuild:,patchless,ccache,norpm,external-patches:,timestamp:,extraversion:,kerneldir:,linux:,lustre:,nodownload,nosrc,noiokit,ofed-version:,mpss-version:,publish,disable-zfs,release,set-value:,src,stage:,target:,target-archs:,with-linux:,xen -- "$@")
1968 if [ $? != 0 ]; then
1972 eval set -- "$options"
2003 if ! KERNELTREE=$(canon_path "$2"); then
2004 fatal 1 "Could not determine the canonical location of $2"
2008 --linux | --with-linux)
2009 if ! LINUX=$(canon_path "$2"); then
2010 fatal 1 "Could not determine the canonical location of $2"
2019 if ! REUSEBUILD=$(canon_path "$2"); then
2020 fatal 1 "Could not determine the canonical location of $2"
2037 if ! KERNELRPMSBASE=$(canon_path "$2"); then
2038 fatal 1 "Could not determine the canonical location of $2"
2047 if ! LUSTRE=$(canon_filepath "$2"); then
2048 fatal 1 "Could not determine the canonical location of $2"
2105 # there are actually some lustre configure flags that we need to
2106 # handle ourselves (but we still give them to configure)
2107 if [[ \ $@\ == *\ --disable-tests\ * ]]; then
2114 usage 1 "Unrecognized option: $1"
2123 # XXX - should we _always_ get the buildid from the META file? what are the
2124 # other (i.e. non-lustre-tarball use cases of lbuild)?
2125 BUILDID=$(sed -n -e 's/^BUILDID = //p' lustre/META)
2129 if [ -n "$OFED_VERSION" -a "$OFED_VERSION" != "inkernel" ]; then
2131 unpack_ofed || fatal 1 "Error unpacking OFED tarball"
2134 if [ -n "$MPSS_VERSION" ]; then
2135 [ -z "$MPSS_DISTRO" ] && MPSS_DISTRO=$(autodetect_distro)
2137 MPSS_INFO=$(mktemp -u mpss-info-XXXXXXXXXX.html)
2138 download_mpss_info "$MPSS_INFO"
2140 if [ "$MPSS_VERSION" = "last" ]; then
2141 MPSS_VERSION=$(parse_mpss_info "$MPSS_INFO" "" ${MPSS_DISTRO})
2142 [ -z "$MPSS_VERSION" ] &&
2143 fatal 1 "Could not determine the last MPSS version"
2146 MPSS_MAJ=${MPSS_VERSION%%.*}
2147 MPSS_VER=${MPSS_VERSION%%-*}
2148 MPSS_BLD=${MPSS_VERSION##*-}
2149 [ "$MPSS_VER" = "$MPSS_BLD" ] && MPSS_BLD=0
2151 download_mpss "$MPSS_INFO"
2152 [ -r "$MPSS_INFO" ] && rm -f "$MPSS_INFO"
2153 echo "Building with MPSS $MPSS_VER-$MPSS_BLD"
2154 unpack_mpss || fatal 1 "Error unpacking MPSS tarballs"
2155 prepare_mpss || fatal 1 "Error preparing MPSS for kernel modules build"
2157 if [ -z "$MPSS_OFED" ]; then
2158 MPSS_OFED=$(find $PWD -type f -path "*/ofed-driver*/Module.symvers" -print -quit)
2159 if [ -n "$MPSS_OFED" ]; then
2160 MPSS_OFED="--with-o2ib=$(dirname $MPSS_OFED)"
2162 MPSS_OFED="--without-o2ib"
2166 # disable unsupported parts:
2172 # define variables for cross compilation:
2174 if [ "$MPSS_MAJ" = "3" ]; then
2175 CC_TARGET_ARCH=k1om-mpss-linux
2176 LINUX="$TOPDIR/mpss"
2177 RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"cross_requires /bin/sh\""
2179 CC_TARGET_ARCH=x86_64-k1om-linux
2180 LINUX="$TOPDIR/mpss/card/kernel"
2181 RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"cross_requires intel-mic-gpl = $MPSS_VER\""
2183 LUSTRE_VERSION=$(sed -n -e 's/^VERSION = //p' lustre/META)
2184 CONFIGURE_FLAGS="$CONFIGURE_FLAGS $MPSS_OFED --host=$CC_TARGET_ARCH --build=x86_64-pc-linux"
2185 RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"post_script build/gen_filelist.sh\""
2186 RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"make_args ARCH=k1om CROSS_COMPILE=${CC_TARGET_ARCH}-\""
2187 RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"cross_path ${CROSS_PATH:=/opt/lustre/${LUSTRE_VERSION}/${CC_TARGET_ARCH}}\""
2188 RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"rootdir %{cross_path}\""
2189 RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_prefix %{cross_path}/usr\""
2190 RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_mandir %{_prefix}/share/man\""
2191 RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_sysconfdir %{cross_path}/etc\""
2192 RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"kmoddir extra\""
2194 # redefine CC for proper ./configure during rpmbuild
2195 export CC=${CC_TARGET_ARCH}-gcc
2198 # make sure the RPM build environment is set up
2199 create_rpmbuild_dirs
2201 # if an unpacked kernel source tree was given on the command line
2202 # just build lustre with it (nothing distro kernel specific here)
2203 if [ -n "$LINUX" ]; then
2204 find_linux_release() {
2205 _find_linux_release $LINUX
2207 build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_VERSION" ||
2208 fatal 1 "error building OFED"
2209 build_lustre "$LINUX" "$LINUXOBJ"
2211 if [ ! -f "${LBUILD_DIR}/lbuild-$DISTROMAJ" ]; then
2212 fatal 1 "${LBUILD_DIR}/lbuild-$DISTROMAJ not found"
2214 source ${LBUILD_DIR}/lbuild-$DISTROMAJ
2215 build_with_srpm || fatal 1 "Failed to build_with_srpm"